`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    20:26:31 11/11/2009 
// Design Name: 
// Module Name:    D-Flip_Flop 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module D_Flip_Flop(CLK, DATA, _SET, _CLEAR, Q, NQ);

	input		CLK, DATA, _SET, _CLEAR;
	output	Q, NQ;

	wire		G1, G2, G3, G4, G5, G6;

	assign	G1 = !(_SET & G4 & G2);
	assign	G2 = !(G1 & _CLEAR & CLK);
	assign	G3 = !(G2 & CLK & G4);
	assign	G4 = !(G3 & _CLEAR & DATA);
	assign	G5 = !(_SET & G2 & G6);
	assign	G6 = !(G3 & G5 & _CLEAR);
	
	assign	Q = G5;
	assign	NQ = G6;

endmodule
