`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    18:37:34 11/20/2009 
// Design Name: 
// Module Name:    Dice3 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module Dice(
	reset0_i ,		// reset
	reset7_i ,		// preset
	mode_i ,			// mode؂ւ
	count_en ,		// countCl[u

	CLK,				// NbŃiRRDRRROOMHj

	seg7_oe_n ,		// 7segLEDIóiR|OFS
	seg7_n ,			// 7segLED\óiV|OFWEEE7 6 5 4 3 2 1 0 -> dp g f e d c b aj

	matrix1_r ,
	matrix1_c ,
	matrix2_r ,
	matrix2_c ,

	led_o				// LED\óiR|OFSj
);

//******************************************************************************//
//////******** o̓s` ********/////////////////////////////////////////////
//******************************************************************************//
	input					reset0_i ;		// Zbg0
	input					reset7_i ;		// Zbg7
	input					mode_i ;			// [hݒ
	input					count_en ;		// COUNTCl[u

	input					CLK ;				// NbN

	output	[3:0]		seg7_oe_n ;		// 7segLEDZNgo
	output	[7:0]		seg7_n ;			// 7segLED\o
	output	[3:0]		led_o ;			// LEDo

	output	[2:0]		matrix1_r ;		// dotmatrix rowo
	output	[2:0]		matrix1_c ;		// dotmatrix columno
	output	[2:0]		matrix2_r ;		// dotmatrix rowo
	output	[2:0]		matrix2_c ;		// dotmatrix columno

//******************************************************************************//
///////******** m[h ********////////////////////////////////////////////////
//******************************************************************************//
	//***** p[^i萔j錾 *****//
	parameter			init_value0 = 6'b000000 ;		// l 0-0
	parameter			init_value7 = 6'b111111 ;		// l 7-7
	parameter			TESTE_cnt	= 32'h01FCA055 ;	// eXgp1bݒ
	parameter			REAL_cnt		= 32'h00008000 ;	// p̐ݒ
	parameter			SEL_cnt		= 32'h00010000 ;	// \؂ւp
	parameter			SET_FLAG		= 1'b1 ;				// tOZbgp
	parameter			RESET_FLAG	= 1'b0			;	// tOZbgp

	//***** WX^錾 *****//
	reg		[5:0]		Q ;					// JE^pWX^
	reg		[7:0]		reg_seg7 ;			// 7ZOg̕\p^[pWX^
	reg		[3:0]		sel_no ;				// 7ZOgIpWX^

	reg		[31:0]	test_cnt ;			// eXg1b쐬pJE^
	reg		[31:0]	sec_cnt ;			// pJE^
	reg		[31:0]	select_cnt ;		// 7segLED\IpJE^

	reg					test_flag ;			// 1btO
	reg					real_flag ;			// 1btO
	reg					sel_flag ;			// 0:7segLED1 - 1:7segLED2
	reg					mode_flag ;			// [hItO

	reg		[5:0]		row = 6'b000001;
	
	//***** C[錾 *****//
	wire		d0, d1, d2, d3, d4, d5 ;		// JE^fR[hpz
	wire		X ;
	wire		[2:0]		rm1 ;
	wire		[2:0]		rm2 ;
	wire		[2:0]		column1 ;
	wire		[2:0]		column2 ;
	wire		m10, m11, m12, m13, m14, m15, m16, m17 ;
	wire		m20, m21, m22, m23, m24, m25, m26, m27 ;

//******************************************************************************//
///////******** H ********/////////////////////////////////////////////////
//******************************************************************************//
	/**** TCRPfR[h ****/
	assign	d0 = (((!Q[2] & !Q[1] & !Q[0])					//m0
					|   (!Q[2] &  Q[1] & !Q[0])					//m2
					|   ( Q[2] & !Q[1] & !Q[0])					//m4
					|   ( Q[2] &  Q[1] & !Q[0])					//m6
					|   ( Q[2] &  Q[1] &  Q[0])) & count_en)	//m7
					| (Q[0] & !count_en);							//!count

	assign	d1 = (((!Q[2] & !Q[1] &  Q[0])					//m1
					|   (!Q[2] &  Q[1] & !Q[0])					//m2
					|   ( Q[2] & !Q[1] &  Q[0])) & count_en)	//m5
					| (Q[1] & !count_en);							//!count

	assign	d2 = (((!Q[2] &  Q[1] &  Q[0])					//m3
					|   ( Q[2] & !Q[1] & !Q[0])					//m4
					|   ( Q[2] & !Q[1] &  Q[0])) & count_en)	//m5
					| (Q[2] & !count_en);							//!count

	/**** TCRQJEgݒ ****/
	assign	X  = (( Q[2] &  Q[1] & !Q[0])						//m6(Dice-1)
					| (!Q[5] & !Q[4] & !Q[3])						//m0(Dice-2)
					| (Q[5] & Q[4] & Q[3]))							//m7(Dice-2)
					& count_en;

	/**** TCRQfR[h ****/
	assign	d3 = (((!Q[5] & !Q[4] & !Q[3])					//m0
					|   (!Q[5] &  Q[4] & !Q[3])					//m2
					|   ( Q[5] & !Q[4] & !Q[3])					//m4
					|   ( Q[5] &  Q[4] & !Q[3])					//m6
					|   ( Q[5] &  Q[4] &  Q[3])) & X)			//m7
					|    (Q[3] & !X);									//!X

	assign	d4 = (((!Q[5] & !Q[4] &  Q[3])					//m1
					|   (!Q[5] &  Q[4] & !Q[3])					//m2
					|   ( Q[5] & !Q[4] &  Q[3])) & X)			//m5
					|    (Q[4] & !X);									//!X

	assign	d5 = (((!Q[5] &  Q[4] &  Q[3])					//m3
					|   ( Q[5] & !Q[4] & !Q[3])					//m4
					|   ( Q[5] & !Q[4] &  Q[3])) & X)			//m5
					|    (Q[5] & !X);									//!X

	/***** hbg}gNXkdc *****/
	assign	m10 = !Q[2] & !Q[1] & !Q[0] ;
	assign	m11 = !Q[2] & !Q[1] &  Q[0] ;
	assign	m12 = !Q[2] &  Q[1] & !Q[0] ;
	assign	m13 = !Q[2] &  Q[1] &  Q[0] ;
	assign	m14 =  Q[2] & !Q[1] & !Q[0] ;
	assign	m15 =  Q[2] & !Q[1] &  Q[0] ;
	assign	m16 =  Q[2] &  Q[1] & !Q[0] ;
	assign	m17 =  Q[2] &  Q[1] &  Q[0] ;

	assign	m20 = !Q[5] & !Q[4] & !Q[3] ;
	assign	m21 = !Q[5] & !Q[4] &  Q[3] ;
	assign	m22 = !Q[5] &  Q[4] & !Q[3] ;
	assign	m23 = !Q[5] &  Q[4] &  Q[3] ;
	assign	m24 =  Q[5] & !Q[4] & !Q[3] ;
	assign	m25 =  Q[5] & !Q[4] &  Q[3] ;
	assign	m26 =  Q[5] &  Q[4] & !Q[3] ;
	assign	m27 =  Q[5] &  Q[4] &  Q[3] ;

	assign	rm1[0] = !row[2] & !row[1] &  row[0] ;
	assign	rm1[1] = !row[2] &  row[1] & !row[0] ;
	assign	rm1[2] =  row[2] & !row[1] & !row[0] ;

	assign	rm2[0] = !row[5] & !row[4] &  row[3] ;
	assign	rm2[1] = !row[5] &  row[4] & !row[3] ;
	assign	rm2[2] =  row[5] & !row[4] & !row[3] ;

	assign	column1[0] = ((rm1[0] | rm1[2]) & m14)
							  | ((rm1[0] | rm1[2]) & m15)
							  | ((rm1[0] | rm1[2]) & m16)
							  | ((rm1[0] | rm1[2]) & m17)
							  |  (rm1[1] & (m16 | m17))
							  |  (rm1[2] & (m12 | m13)) ;
	assign	column1[1] = (rm1[1]) & (m11 | m13 | m15 | m17);
	
	assign	column1[2] = (rm1[0] & m12)
							  | (rm1[0] & m13)
							  | ((rm1[0] | rm1[2]) & m14)
							  | ((rm1[0] | rm1[2]) & m15)
							  | ((rm1[0] | rm1[1] | rm1[2]) & m16)
							  | ((rm1[0] | rm1[1] | rm1[2]) & m17);

	assign	column2[0] = ((rm2[0] | rm2[2]) & m24)
							  | ((rm2[0] | rm2[2]) & m25)
							  | ((rm2[0] | rm2[2]) & m26)
							  | ((rm2[0] | rm2[2]) & m27)
							  |  (rm2[1] & (m26 | m27))
							  |  (rm2[2] & (m22 | m23)) ;
	assign	column2[1] = (rm2[1]) & (m21 | m23 | m25 | m27);
	assign	column2[2] = (rm2[0] & m22)
							  | (rm2[0] & m23)
							  | ((rm2[0] | rm2[2]) & m24)
							  | ((rm2[0] | rm2[2]) & m25)
							  | ((rm2[0] | rm2[1] | rm2[2]) & m26)
							  | ((rm2[0] | rm2[1] | rm2[2]) & m27);

	/***** \pf[^E\ʒu|[go *****/
	// 7segLED //
	assign	seg7_oe_n = sel_no ;				// 7segLED\ʒu|[go
	assign 	seg7_n = ~reg_seg7 ;				// 7segLED\f[^|[go

	// LED //
	assign	led_o[0] = ~reset0_i ;			// LED1 reset̓j^|[go
	assign	led_o[1] = ~reset7_i ;			// LED2 preset̓j^|[go
	assign	led_o[2] = ~mode_flag ;				// LED3 NmFpj^|[go
	assign	led_o[3] = ~count_en ;			// LED4 countCl[u̓j^|[go
	assign	matrix1_r = row[2:0] ;
	assign	matrix1_c = ~column1 ;
	assign	matrix2_r = row[5:3] ;
	assign	matrix2_c = ~column2 ;

//******************************************************************************//
//////////////////////////////////////////////////////////////////////////////////
//******************************************************************************//
/***************************************/
/*		샂[hݒ蕔			*/
/***************************************/
	always @(posedge mode_i)
	begin
		if (mode_flag == 1'b0)
			begin
				mode_flag <= SET_FLAG ;		//[htOZbg
			end
		else
			begin
				mode_flag <= RESET_FLAG ;	//[htOZbg
			end
	end

/***************************************/
/*		7segLED \SELECTJE^			*/
/*		TOOg					*/
/***************************************/
	always @(posedge CLK)
	begin
	/////@\tOݒ@//////////
		if ( select_cnt == SEL_cnt )			// \SELECTJE^؂ւJEg
			begin
				select_cnt <= 32'h00000000 ;	// JE^Zbg
				sel_flag	<= sel_flag ^ 1'b1;	// sel_FLAG𔽓]
				if ((reset0_i == RESET_FLAG) & (reset7_i == RESET_FLAG))
					begin
						row[5] <= row[4] ;
						row[4] <= row[3] ;
						row[3] <= row[2] ;
						row[2] <= row[1] ;
						row[1] <= row[0] ;
						row[0] <= row[5] ;
					end
				else
					begin
					if ((reset0_i == SET_FLAG) | (reset7_i == SET_FLAG))
						begin
							row <= 6'b000001 ;
						end
					end
			end
		else						// \SELECTJE^؂ւJEg
			begin
				select_cnt <= select_cnt + 1 ;// JE^CNg
			end
	end

/***************************************/
/*		eXgJEgAbv@JE^				*/
/***************************************/
	always @(posedge CLK)
	begin
	/////@K莞ԁiPbjJEgtOݒ@/////
		if ( test_cnt == TESTE_cnt )
			begin										// 	KliPbjJEg
				test_cnt		<= 32'h00000000 ;	//    JE^Zbg
				test_flag	<= 1'b1 ;			//    SEC1_FLAG1Zbg
			end
		else
			begin										//		Pb
				test_cnt		<= test_cnt + 1 ;	//    JE^́{PÂ
				test_flag	<= 1'b0 ;			//    SEC1_FLAG0ɃZbg
			end
	end

/***************************************/
/*		JEgAbv@JE^					*/
/***************************************/
	always @(posedge CLK)
	begin
	/////@K莞ԁiPbjJEgtOݒ@/////
		if ( sec_cnt == REAL_cnt )
			begin										// 	KliPbjJEg
				sec_cnt		<= 32'h00000000 ;	//    JE^Zbg
				real_flag	<= 1'b1 ;			//    SEC1_FLAG1Zbg
			end
		else
			begin										//		Pb
				sec_cnt		<= sec_cnt + 1 ;	//    JE^́{PÂ
				real_flag	<= 1'b0 ;			//    SEC1_FLAG0ɃZbg
			end
	end

/***************************************/
/*  		Zbg/JE^					*/
/***************************************/
	always @(posedge CLK or posedge reset0_i or posedge reset7_i)
	begin
	/////@Zbg@//////////
		if ( reset0_i == 1'b1 )			// Zbgꂽ
			begin
				Q <= init_value0 ;		// OStbvtbvɐݒ
			end
		else begin
			if ( reset7_i == 1'b1 )		// vZbgꂽ
				begin
					Q <= init_value7 ;	// PStbvtbvɐݒ
				end
			else begin
				// ieXg[hj
				if (((test_flag == SET_FLAG) & (mode_flag == RESET_FLAG))
				|  ((real_flag == SET_FLAG) & (mode_flag == SET_FLAG  )))
					begin
						/**** TCRPJEg ****/
						Q[0] <= d0	 ;	// 
						Q[1] <= d1	 ;	// 
						Q[2] <= d2	 ;	//
				
						/**** TCRQJEg ****/
						Q[3] <= d3	 ;	// 
						Q[4] <= d4	 ;	// 
						Q[5] <= d5	 ;	//
					end
			end
		end
	end

/***************************************/
/*					VZOg\			*/
/***************************************/
	/**** TCRP̕\ݒ ****/
	always @(posedge CLK)
	begin
		if ( sel_flag == 1'b0 )
			begin
				case ( Q[2:0] )
					3'b000 : reg_seg7 <= 8'b10111111 ;		// '0' \
					3'b001 : reg_seg7 <= 8'b00000110 ;		// '1' \
					3'b010 : reg_seg7 <= 8'b11011011 ;		// '2' \
					3'b011 : reg_seg7 <= 8'b01001111 ;		// '3' \
					3'b100 : reg_seg7 <= 8'b11100110 ;		// '4' \
					3'b101 : reg_seg7 <= 8'b01101101 ;		// '5' \
					3'b110 : reg_seg7 <= 8'b11111101 ;		// '6' \
					3'b111 : reg_seg7 <= 8'b00100111 ;		// '7' \
				endcase
				sel_no <= 4'b1110 ;		// 7sedgLED-1I
			end

	/**** TCRQ̕\ݒ ****/
		else
		if ( sel_flag == 1'b1 )
			begin
				case ( Q[5:3] )
					3'b000 : reg_seg7 <= 8'b10111111 ;		// '0' \
					3'b001 : reg_seg7 <= 8'b00000110 ;		// '1' \
					3'b010 : reg_seg7 <= 8'b11011011 ;		// '2' \
					3'b011 : reg_seg7 <= 8'b01001111 ;		// '3' \
					3'b100 : reg_seg7 <= 8'b11100110 ;		// '4' \
					3'b101 : reg_seg7 <= 8'b01101101 ;		// '5' \
					3'b110 : reg_seg7 <= 8'b11111101 ;		// '6' \
					3'b111 : reg_seg7 <= 8'b00100111 ;		// '7' \
				endcase
				sel_no <= 4'b1101 ;		// 7sedgLED-2I
			end
	end

endmodule
