`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    23:37:54 06/07/2010 
// Design Name: 
// Module Name:    Top 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module Top(SW_In, LED_Out);
	input		[4:1] SW_In ;	// SW
	output	[4:1]LED_Out ;		// LEDo

	wire CLK, DATA, SET, CLEAR, Q_OUT, NQ_OUT;

	assign CLK   = !SW_In[1];
	assign DATA  = !SW_In[4];
	assign SET   = SW_In[2];
	assign CLEAR = SW_In[3];


	assign LED_Out[1] = !Q_OUT;
	assign LED_Out[2] = 1'b1;
	assign LED_Out[3] = 1'b1;
	assign LED_Out[4] = !NQ_OUT;

	D_Flip_Flop D_Flip_Flop(CLK, DATA, SET, CLEAR, Q_OUT, NQ_OUT);
endmodule
