`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    01:21:12 10/28/2009 
// Design Name: 
// Module Name:    majority 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module majority(IN_A, IN_B, IN_C, OUT_X, LED2, LED3, LED4, LED5, LED6, LED7, LED8);
	input IN_A;
	input IN_B;
	input IN_C;
	output OUT_X;
	output LED2, LED3, LED4, LED5, LED6, LED7, LED8;
   
	wire AND_AB;
	wire AND_AC;
	wire AND_BC;
	wire OR_X;
   
	AND2 AND_1 (.I0(!IN_A), .I1(!IN_B), .O(AND_AB));
	AND2 AND_2 (.I0(!IN_A), .I1(!IN_C), .O(AND_AC));
	AND2 AND_3 (.I0(!IN_B), .I1(!IN_C), .O(AND_BC));
	OR3 OR_1 (.I0(AND_BC), .I1(AND_AC), .I2(AND_AB), .O(OR_X));
	
	assign OUT_X = !OR_X;
	assign LED2 = 1'b1;
	assign LED3 = 1'b1;
	assign LED4 = 1'b1;
	assign LED5 = 1'b1;
	assign LED6 = 1'b1;
	assign LED7 = 1'b1;
	assign LED8 = 1'b1;
	
endmodule
