`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    23:49:17 05/17/2010 
// Design Name: 
// Module Name:    majority2 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module majority2(
	IN_A,
	IN_B,
	IN_C,

	OUT_X,
	LED2,
	LED3,
	LED4
);

input		IN_A;
input		IN_B;
input 	IN_C;

output 	OUT_X;
output 	LED2;
output 	LED3;
output 	LED4;

wire	ab;
wire	bc;
wire	ac;

assign	LED2 = 1'b1;
assign	LED3 = 1'b1;
assign	LED4 = 1'b1;

assign	ab = !IN_A & !IN_B;
assign	bc = !IN_B & !IN_C;
assign	ac = !IN_A & !IN_C;

assign	OUT_X = (ab | bc | ac);

endmodule
